=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpFileClient
  class DistributionsFileApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role for this object to users/groups.
    # @param file_file_distribution_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(file_file_distribution_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(file_file_distribution_href, nested_role, opts)
      data
    end

    # Add a role for this object to users/groups.
    # @param file_file_distribution_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(file_file_distribution_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.add_role ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling DistributionsFileApi.add_role"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}add_role/'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a file distribution
    # Trigger an asynchronous create task
    # @param file_file_distribution [FileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(file_file_distribution, opts = {})
      data, _status_code, _headers = create_with_http_info(file_file_distribution, opts)
      data
    end

    # Create a file distribution
    # Trigger an asynchronous create task
    # @param file_file_distribution [FileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(file_file_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.create ...'
      end
      # verify the required parameter 'file_file_distribution' is set
      if @api_client.config.client_side_validation && file_file_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution' when calling DistributionsFileApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/distributions/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a file distribution
    # Trigger an asynchronous delete task
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(file_file_distribution_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(file_file_distribution_href, opts)
      data
    end

    # Delete a file distribution
    # Trigger an asynchronous delete task
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(file_file_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.delete ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.delete"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List file distributions
    #  FileDistributions host File Publications which makes the metadata and the referenced File Content available to HTTP clients. Additionally, a FileDistribution with an associated FilePublication can be the target url of a File Remote , allowing another instance of Pulp to sync the content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :base_path Filter results where base_path matches value
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [Array<String>] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :with_content Filter distributions based on the content served by them
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedfileFileDistributionResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List file distributions
    #  FileDistributions host File Publications which makes the metadata and the referenced File Content available to HTTP clients. Additionally, a FileDistribution with an associated FilePublication can be the target url of a File Remote , allowing another instance of Pulp to sync the content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :base_path Filter results where base_path matches value
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [Array<String>] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :with_content Filter distributions based on the content served by them
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedfileFileDistributionResponseList, Integer, Hash)>] PaginatedfileFileDistributionResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.list ...'
      end
      allowable_values = ["-base_path", "-name", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "base_path", "name", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/distributions/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'base_path'] = opts[:'base_path'] if !opts[:'base_path'].nil?
      query_params[:'base_path__contains'] = opts[:'base_path__contains'] if !opts[:'base_path__contains'].nil?
      query_params[:'base_path__icontains'] = opts[:'base_path__icontains'] if !opts[:'base_path__icontains'].nil?
      query_params[:'base_path__in'] = @api_client.build_collection_param(opts[:'base_path__in'], :csv) if !opts[:'base_path__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'with_content'] = opts[:'with_content'] if !opts[:'with_content'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedfileFileDistributionResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles assigned to this object.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(file_file_distribution_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(file_file_distribution_href, opts)
      data
    end

    # List roles assigned to this object.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(file_file_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.list_roles ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.list_roles"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}list_roles/'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ObjectRolesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List permissions available to the current user on this object.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(file_file_distribution_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(file_file_distribution_href, opts)
      data
    end

    # List permissions available to the current user on this object.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(file_file_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.my_permissions ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.my_permissions"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}my_permissions/'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MyPermissionsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file distribution
    # Trigger an asynchronous partial update task
    # @param file_file_distribution_href [String] 
    # @param patchedfile_file_distribution [PatchedfileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(file_file_distribution_href, patchedfile_file_distribution, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(file_file_distribution_href, patchedfile_file_distribution, opts)
      data
    end

    # Update a file distribution
    # Trigger an asynchronous partial update task
    # @param file_file_distribution_href [String] 
    # @param patchedfile_file_distribution [PatchedfileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(file_file_distribution_href, patchedfile_file_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.partial_update ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.partial_update"
      end
      # verify the required parameter 'patchedfile_file_distribution' is set
      if @api_client.config.client_side_validation && patchedfile_file_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'patchedfile_file_distribution' when calling DistributionsFileApi.partial_update"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedfile_file_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a file distribution
    #  FileDistributions host File Publications which makes the metadata and the referenced File Content available to HTTP clients. Additionally, a FileDistribution with an associated FilePublication can be the target url of a File Remote , allowing another instance of Pulp to sync the content.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [FileFileDistributionResponse]
    def read(file_file_distribution_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_file_distribution_href, opts)
      data
    end

    # Inspect a file distribution
    #  FileDistributions host File Publications which makes the metadata and the referenced File Content available to HTTP clients. Additionally, a FileDistribution with an associated FilePublication can be the target url of a File Remote , allowing another instance of Pulp to sync the content.
    # @param file_file_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FileFileDistributionResponse, Integer, Hash)>] FileFileDistributionResponse data, response status code and response headers
    def read_with_http_info(file_file_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.read ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.read"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FileFileDistributionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role for this object from users/groups.
    # @param file_file_distribution_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(file_file_distribution_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(file_file_distribution_href, nested_role, opts)
      data
    end

    # Remove a role for this object from users/groups.
    # @param file_file_distribution_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(file_file_distribution_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.remove_role ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling DistributionsFileApi.remove_role"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}remove_role/'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file distribution
    # Trigger an asynchronous update task
    # @param file_file_distribution_href [String] 
    # @param file_file_distribution [FileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(file_file_distribution_href, file_file_distribution, opts = {})
      data, _status_code, _headers = update_with_http_info(file_file_distribution_href, file_file_distribution, opts)
      data
    end

    # Update a file distribution
    # Trigger an asynchronous update task
    # @param file_file_distribution_href [String] 
    # @param file_file_distribution [FileFileDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(file_file_distribution_href, file_file_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsFileApi.update ...'
      end
      # verify the required parameter 'file_file_distribution_href' is set
      if @api_client.config.client_side_validation && file_file_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution_href' when calling DistributionsFileApi.update"
      end
      # verify the required parameter 'file_file_distribution' is set
      if @api_client.config.client_side_validation && file_file_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_distribution' when calling DistributionsFileApi.update"
      end
      # resource path
      local_var_path = '{file_file_distribution_href}'.sub('{' + 'file_file_distribution_href' + '}', CGI.escape(file_file_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsFileApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
